//+------------------------------------------------------------------+
//|                                                  Butterworth.mq4 |
//|                       Public Domain, Ralph Ronnquist and JustiZe |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Public Domain, Ralph Ronnquist and JustiZe"
#property link      ""

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Green


extern double    F=0.8633;
extern double    G=-0.7265;

double output_noise[];
double output_sma[];

int init()
{
    int index;
    
    index = 0;
    SetIndexStyle( index, DRAW_LINE );
    SetIndexBuffer( index, output_noise );
    SetIndexLabel( index, "output" );
    SetIndexStyle( index+1, DRAW_LINE );
    SetIndexBuffer( index+1, output_sma );
    SetIndexLabel( index+1, "output2" );
    
    return(0);
}

int deinit()
{
    return(0);
}

int start()
{
    for ( int bar = Bars - IndicatorCounted(); bar >= 0; bar-- ) {
        indicate( bar );
    }
    return(0);
}

void indicate(int bar)
{
    if ( bar + 5 >= Bars ) {
        output_noise[ bar ] = 0;
        output_sma[ bar ] = 0;
    } else {
        output_noise[ bar ] = F * Close[ bar]  - F * Close[ bar+1 ] - G * output_noise[ bar+1 ];
        output_sma[ bar ]   = (output_noise[ bar ] + output_noise[ bar+1 ] + output_noise[ bar+2 ]) / 3;
    }
}
//+------------------------------------------------------------------+